<template>
    <div
        v-if="pageReady"
        class="w-full px-2 py-4"
    >
        <auto-form
            ref="form"
            :password2-verify="true"
            :fields="formFields"
        />
        <div>
            <auto-button
                type="primary"
                block
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import {inject, nextTick, onMounted, ref} from "vue";
import AutoForm from "~/components/auto-form.vue";
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";
import {useUserStore} from "~/stores/user.js";

const $helper = inject('$helper');
const i18n = useI18n();
const pageReady = ref(true);
const form = ref();
const formFields = ref([
    {
        type: 'password',
        name: 'new_password',
        label: i18n.t('new_password'),
        placeholder: i18n.t('leave_blank_if_not_changing'),
        dark: true,
        size: 'lg',
    },
    {
        type: 'password',
        name: 'new_password_confirmation',
        label: i18n.t('new_password_confirmation'),
        placeholder: i18n.t('leave_blank_if_not_changing'),
        dark: true,
        size: 'lg',
    },
    {
        type: 'pin',
        name: 'new_password2',
        label: i18n.t('new_password2'),
        placeholder: i18n.t('leave_blank_if_not_changing'),
        dark: true,
        size: 'lg',
    },
    {
        type: 'pin',
        name: 'new_password2_confirmation',
        label: i18n.t('new_password2_confirmation'),
        placeholder: i18n.t('leave_blank_if_not_changing'),
        dark: true,
        size: 'lg',
    }
]);

const $userStore = useUserStore();

const submitForm = async () => {
    try {
        await form.value.submitForm('/security_submit', async (resp) => {
            await $helper.alertSuccess({
                message: resp.message,
                callback: async () => {
                    pageReady.value = false;
                    await $userStore.fetchAccount();
                    await nextTick(() => {
                        pageReady.value = true;
                    });
                }
            });
        });
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    await $userStore.fetchAccount();
});
</script>
